<?xml version="1.0" encoding="<XDtConfig:configParameterValue paramName='Xmlencoding'/>"?>
<!DOCTYPE jboss PUBLIC "<XDtXml:publicId/>" "<XDtXml:systemId/>">

<jboss>

 <XDtMerge:merge file="jboss-security.xml">
  <XDtConfig:ifHasConfigParam paramName="EnforceEjbRestrictions" optional="true">
   <enforce-ejb-restrictions><XDtConfig:configParameterValue paramName="EnforceEjbRestrictions"/></enforce-ejb-restrictions>
  </XDtConfig:ifHasConfigParam>
  <XDtConfig:ifHasConfigParam paramName="SecurityDomain" optional="true">
   <security-domain><XDtConfig:configParameterValue paramName="SecurityDomain"/></security-domain>
  </XDtConfig:ifHasConfigParam>
  <XDtConfig:ifHasConfigParam paramName="UnauthenticatedPrincipal" optional="true">
   <unauthenticated-principal><XDtConfig:configParameterValue paramName="UnauthenticatedPrincipal"/></unauthenticated-principal>
  </XDtConfig:ifHasConfigParam>
 </XDtMerge:merge>

   <enterprise-beans>

  <XDtMerge:merge file="jboss-beans.xml">
     <!--
       To add beans that you have deployment descriptor info for, add
       a file to your XDoclet merge directory called jboss-beans.xml that contains
       the <session></session>, <entity></entity> and <message-driven></message-driven>
       markup for those beans.
     -->
  </XDtMerge:merge>

   <XDtEjbEntity:forAllEntityBeans>
    <XDtEjb:ifIsAConcreteEJBean>
     <XDtMerge:merge file="jboss-{0}.xml"> 
      <entity>
         <ejb-name><XDtEjb:ejbName/></ejb-name>
        <XDtEjb:ifRemoteEjb>
         <jndi-name><XDtEjbHome:jndiName type="remote"/></jndi-name>
        </XDtEjb:ifRemoteEjb>
        <XDtEjb:ifLocalEjb>
         <local-jndi-name><XDtEjbHome:jndiName type="local"/></local-jndi-name>
        </XDtEjb:ifLocalEjb>
        <XDtClass:ifHasClassTag tagName="jboss:read-only" paramName="read-only" paramNum="0">
         <read-only><XDtClass:classTagValue tagName="jboss:read-only" paramName="read-only" paramNum="0"/></read-only>
        </XDtClass:ifHasClassTag>
        <XDtClass:ifHasClassTag tagName="jboss:container-configuration">
         <configuration-name><XDtClass:classTagValue tagName="jboss:container-configuration" paramName="name"/></configuration-name>
        </XDtClass:ifHasClassTag>
        <XDtConfig:ifConfigParamGreaterOrEquals paramName="Version" value="3.1">
        <XDtClass:ifHasClassTag tagName="jboss:cache-invalidation" superclasses="true">
         <cache-invalidation><XDtClass:classTagValue tagName="jboss:cache-invalidation" paramName="value" default="true" values="true,True" superclasses="true"/></cache-invalidation>
            <XDtClass:ifHasClassTag tagName="jboss:cache-invalidation-config">
         <cache-invalidation-config>
                <XDtClass:ifHasClassTag tagName="jboss:cache-invalidation-config" paramName="invalidation-manager-name">
             <invalidation-manager-name><XDtClass:classTagValue tagName="jboss:cache-invalidation-config" paramName="invalidation-manager-name"/></invalidation-manager-name>
                </XDtClass:ifHasClassTag>
                <XDtClass:ifHasClassTag tagName="jboss:cache-invalidation-config" paramName="invalidation-group-name">
             <invalidation-group-name><XDtClass:classTagValue tagName="jboss:cache-invalidation-config" paramName="invalidation-group-name"/></invalidation-group-name>
                </XDtClass:ifHasClassTag>
         </cache-invalidation-config>
            </XDtClass:ifHasClassTag>
        </XDtClass:ifHasClassTag>
        </XDtConfig:ifConfigParamGreaterOrEquals>
        <XDtClass:ifHasClassTag tagName="jboss:security-proxy">
         <security-proxy><XDtClass:classTagValue tagName="jboss:security-proxy" paramName="name"/></security-proxy>
        </XDtClass:ifHasClassTag>
        <XDtClass:forAllClassTags tagName="jboss:ejb-ref-jndi">
         <ejb-ref>
            <ejb-ref-name>ejb/<XDtClass:classTagValue tagName="jboss:ejb-ref-jndi" paramName="ref-name"/></ejb-ref-name>
            <jndi-name><XDtClass:classTagValue tagName="jboss:ejb-ref-jndi" paramName="jndi-name"/></jndi-name>
         </ejb-ref>
        </XDtClass:forAllClassTags>
        <XDtClass:forAllClassTags tagName="jboss:resource-ref">
         <resource-ref>
            <res-ref-name><XDtClass:classTagValue tagName="jboss:resource-ref" paramName="res-ref-name"/></res-ref-name>
            <XDtClass:ifHasClassTag tagName="jboss:resource-ref" paramName="resource-name">
            <resource-name><XDtClass:classTagValue tagName="jboss:resource-ref" paramName="resource-name"/></resource-name>
            </XDtClass:ifHasClassTag>
            <XDtClass:ifHasClassTag tagName="jboss:resource-ref" paramName="jndi-name">
            <jndi-name><XDtClass:classTagValue tagName="jboss:resource-ref" paramName="jndi-name"/></jndi-name>
            </XDtClass:ifHasClassTag>
            <XDtClass:ifHasClassTag tagName="jboss:resource-ref" paramName="res-url">
            <res-url><XDtClass:classTagValue tagName="jboss:resource-ref" paramName="res-url"/></res-url>
            </XDtClass:ifHasClassTag>
         </resource-ref>
         </XDtClass:forAllClassTags>
         <XDtClass:forAllClassTags tagName="jboss:resource-env-ref">
         <resource-env-ref>
            <resource-env-ref-name><XDtClass:classTagValue tagName="jboss:resource-env-ref" paramName="resource-env-ref-name" mandatory="true"/></resource-env-ref-name>
            <jndi-name><XDtClass:classTagValue tagName="jboss:resource-env-ref" paramName="jndi-name" mandatory="true"/></jndi-name>
         </resource-env-ref>
         </XDtClass:forAllClassTags>

<XDtComment:comment>
We can get away with including an empty method-attributes element for >= 3.2, as
the DTD defines it as (method*), which may occur zero times.
</XDtComment:comment>
        <XDtConfig:ifConfigParamGreaterOrEquals paramName="Version" value="3.2">
        <method-attributes>
        <XDtClass:forAllClassTags tagName="jboss.method-attributes">
            <method>
              <method-name><XDtClass:classTagValue tagName="jboss.method-attributes" paramName="pattern"/></method-name>
              <read-only><XDtClass:classTagValue tagName="jboss.method-attributes" paramName="read-only" /></read-only>              
            </method>
        </XDtClass:forAllClassTags>
        <XDtMethod:forAllMethods>
          <XDtMethod:ifHasMethodTag tagName="jboss.method-attributes">
            <method>
              <method-name><XDtEjbIntf:interfaceMethodName /></method-name>
              <read-only><XDtMethod:methodTagValue tagName="jboss.method-attributes" paramName="read-only" /></read-only>
              <copy-restore><XDtMethod:methodTagValue tagName="jboss.method-attributes" paramName="copy-restore" /></copy-restore>              
            </method>
          </XDtMethod:ifHasMethodTag>
        </XDtMethod:forAllMethods> 
        </method-attributes>
        </XDtConfig:ifConfigParamGreaterOrEquals>

      <XDtClass:ifHasClassTag tagName="jboss:clustered" superclasses="true">
          <clustered><XDtClass:classTagValue tagName="jboss:clustered" paramName="cluster" default="true" values="true,false"/></clustered>
          <XDtClass:ifHasClassTag tagName="jboss:cluster-config" superclasses="true">
          <cluster-config>
              <XDtClass:ifHasClassTag tagName="jboss:cluster-config" paramName="partition-name" superclasses="true">
              <partition-name><XDtClass:classTagValue tagName="jboss:cluster-config" paramName="partition-name"/></partition-name>
              </XDtClass:ifHasClassTag>
              <XDtClass:ifHasClassTag tagName="jboss:cluster-config" paramName="home-policy" superclasses="true">
              <home-load-balance-policy><XDtClass:classTagValue tagName="jboss:cluster-config" paramName="home-policy" superclasses="true"/></home-load-balance-policy>
              </XDtClass:ifHasClassTag>
              <XDtClass:ifHasClassTag tagName="jboss:cluster-config" paramName="bean-policy" superclasses="true">
              <bean-load-balance-policy><XDtClass:classTagValue tagName="jboss:cluster-config" paramName="bean-policy" superclasses="true"/></bean-load-balance-policy>
            </XDtClass:ifHasClassTag>
          </cluster-config>
         </XDtClass:ifHasClassTag>
      </XDtClass:ifHasClassTag> 

<XDtComment:comment>
For 3.0, method-attributes occurs in a different place in the entity element, and
is defined as (method-name, read-only?)  Since there can only be one method-name,
we'll assume it's defined with a single class level tag.  If you've got 20 methods,
you're not going to define it on just one of them with a method level tag...
</XDtComment:comment>
        <XDtConfig:ifConfigParamEquals paramName="Version" value="3.0">
        <XDtClass:ifHasClassTag tagName="jboss.method-attributes">
        <method-attributes>
              <method-name><XDtClass:classTagValue tagName="jboss.method-attributes" paramName="pattern"/></method-name>
              <read-only><XDtClass:classTagValue tagName="jboss.method-attributes" paramName="read-only" /></read-only>
        </method-attributes>
        </XDtClass:ifHasClassTag>
        </XDtConfig:ifConfigParamEquals>
      </entity>
     </XDtMerge:merge> 
    </XDtEjb:ifIsAConcreteEJBean> 
   </XDtEjbEntity:forAllEntityBeans>

   <XDtEjbSession:forAllSessionBeans>
    <XDtEjb:ifIsAConcreteEJBean>
     <XDtMerge:merge file="jboss-{0}.xml">
      <session>
         <ejb-name><XDtEjb:ejbName/></ejb-name>
        <XDtEjb:ifRemoteEjb>
         <jndi-name><XDtEjbHome:jndiName type="remote"/></jndi-name>
        </XDtEjb:ifRemoteEjb>
        <XDtEjb:ifLocalEjb>
         <local-jndi-name><XDtEjbHome:jndiName type="local"/></local-jndi-name>
        </XDtEjb:ifLocalEjb>
        <XDtClass:ifHasClassTag tagName="jboss:container-configuration">
         <configuration-name><XDtClass:classTagValue tagName="jboss:container-configuration" paramName="name"/></configuration-name>
        </XDtClass:ifHasClassTag>
        <XDtClass:ifHasClassTag tagName="jboss:security-proxy">
         <security-proxy><XDtClass:classTagValue tagName="jboss:security-proxy" paramName="name"/></security-proxy>
        </XDtClass:ifHasClassTag>
        <XDtClass:forAllClassTags tagName="jboss:ejb-ref-jndi">
         <ejb-ref>
            <ejb-ref-name>ejb/<XDtClass:classTagValue tagName="jboss:ejb-ref-jndi" paramName="ref-name"/></ejb-ref-name>
            <jndi-name><XDtClass:classTagValue tagName="jboss:ejb-ref-jndi" paramName="jndi-name"/></jndi-name>
         </ejb-ref>
        </XDtClass:forAllClassTags>
        <XDtClass:forAllClassTags tagName="jboss:resource-ref">
         <resource-ref>
            <res-ref-name><XDtClass:classTagValue tagName="jboss:resource-ref" paramName="res-ref-name"/></res-ref-name>
            <XDtClass:ifHasClassTag tagName="jboss:resource-ref" paramName="resource-name">
            <resource-name><XDtClass:classTagValue tagName="jboss:resource-ref" paramName="resource-name"/></resource-name>
            </XDtClass:ifHasClassTag>
            <XDtClass:ifHasClassTag tagName="jboss:resource-ref" paramName="jndi-name">
            <jndi-name><XDtClass:classTagValue tagName="jboss:resource-ref" paramName="jndi-name"/></jndi-name>
            </XDtClass:ifHasClassTag>
            <XDtClass:ifHasClassTag tagName="jboss:resource-ref" paramName="res-url">
            <res-url><XDtClass:classTagValue tagName="jboss:resource-ref" paramName="res-url"/></res-url>
            </XDtClass:ifHasClassTag>
         </resource-ref>
         </XDtClass:forAllClassTags>
         <XDtClass:forAllClassTags tagName="jboss:resource-env-ref">
         <resource-env-ref>
            <resource-env-ref-name><XDtClass:classTagValue tagName="jboss:resource-env-ref" paramName="resource-env-ref-name" mandatory="true"/></resource-env-ref-name>
            <jndi-name><XDtClass:classTagValue tagName="jboss:resource-env-ref" paramName="jndi-name" mandatory="true"/></jndi-name>
         </resource-env-ref>
         </XDtClass:forAllClassTags>
      <XDtClass:ifHasClassTag tagName="jboss:clustered" superclasses="true">
          <clustered><XDtClass:classTagValue tagName="jboss:clustered" paramName="cluster" default="true" values="true,false"/></clustered>
          <XDtClass:ifHasClassTag tagName="jboss:cluster-config" superclasses="true">
          <cluster-config>
              <XDtClass:ifHasClassTag tagName="jboss:cluster-config" paramName="partition-name" superclasses="true">
              <partition-name><XDtClass:classTagValue tagName="jboss:cluster-config" paramName="partition-name"/></partition-name>
              </XDtClass:ifHasClassTag>
              <XDtClass:ifHasClassTag tagName="jboss:cluster-config" paramName="home-policy" superclasses="true">
              <home-load-balance-policy><XDtClass:classTagValue tagName="jboss:cluster-config" paramName="home-policy" superclasses="true"/></home-load-balance-policy>
              </XDtClass:ifHasClassTag>
              <XDtClass:ifHasClassTag tagName="jboss:cluster-config" paramName="bean-policy" superclasses="true">
              <bean-load-balance-policy><XDtClass:classTagValue tagName="jboss:cluster-config" paramName="bean-policy" superclasses="true"/></bean-load-balance-policy>
              </XDtClass:ifHasClassTag>
              <XDtEjbSession:ifStatefulSession>
                 <XDtClass:ifHasClassTag tagName="jboss:cluster-config" paramName="state-manager" superclasses="true">
              <session-state-manager-jndi-name><XDtClass:classTagValue tagName="jboss:cluster-config" paramName="state-manager" superclasses="true"/></session-state-manager-jndi-name>
                  </XDtClass:ifHasClassTag>
              </XDtEjbSession:ifStatefulSession>
          </cluster-config>
          </XDtClass:ifHasClassTag>
      </XDtClass:ifHasClassTag>
<XDtComment:comment>
Although in session beans, method-attributes occurs in the same place for both
3.0 and 3.2, its definition is still different.  They're handled separately
as that's easiest - I can just copy and paste both sections from above :-)
</XDtComment:comment>
        <XDtConfig:ifConfigParamEquals paramName="Version" value="3.0">
        <XDtClass:ifHasClassTag tagName="jboss.method-attributes">
        <method-attributes>
              <method-name><XDtClass:classTagValue tagName="jboss.method-attributes" paramName="pattern"/></method-name>
              <read-only><XDtClass:classTagValue tagName="jboss.method-attributes" paramName="read-only" /></read-only>
        </method-attributes>
        </XDtClass:ifHasClassTag>
        </XDtConfig:ifConfigParamEquals>
        <XDtConfig:ifConfigParamGreaterOrEquals paramName="Version" value="3.2">
        <method-attributes>
        <XDtClass:forAllClassTags tagName="jboss.method-attributes">
            <method>
              <method-name><XDtClass:classTagValue tagName="jboss.method-attributes" paramName="pattern"/></method-name>
              <read-only><XDtClass:classTagValue tagName="jboss.method-attributes" paramName="read-only" /></read-only>
            </method>
        </XDtClass:forAllClassTags>
        <XDtMethod:forAllMethods>
          <XDtMethod:ifHasMethodTag tagName="jboss.method-attributes">
            <method>
              <method-name><XDtEjbIntf:interfaceMethodName /></method-name>
              <read-only><XDtMethod:methodTagValue tagName="jboss.method-attributes" paramName="read-only" /></read-only>
              <copy-restore><XDtMethod:methodTagValue tagName="jboss.method-attributes" paramName="copy-restore" /></copy-restore>
            </method>
          </XDtMethod:ifHasMethodTag>
        </XDtMethod:forAllMethods> 
        </method-attributes>
        </XDtConfig:ifConfigParamGreaterOrEquals>
      </session>
     </XDtMerge:merge>
    </XDtEjb:ifIsAConcreteEJBean>
   </XDtEjbSession:forAllSessionBeans>



    <XDtConfig:ifConfigParamGreaterOrEquals paramName="EjbSpec" value="2.0">
    <XDtEjbMdb:forAllMDBeans>
    <XDtEjb:ifIsAConcreteEJBean>
     <XDtMerge:merge file="jboss-{0}.xml">
      <message-driven>
         <ejb-name><XDtEjb:ejbName/></ejb-name>
         <destination-jndi-name><XDtClass:classTagValue tagName="jboss:destination-jndi-name,jboss:destination-jndi-name" paramName="name"/></destination-jndi-name>
        <XDtClass:ifHasClassTag tagName="jboss:container-configuration">
         <configuration-name><XDtClass:classTagValue tagName="jboss:container-configuration" paramName="name"/></configuration-name>
        </XDtClass:ifHasClassTag>
        <XDtClass:ifHasClassTag tagName="jboss:security-proxy">
         <security-proxy><XDtClass:classTagValue tagName="jboss:security-proxy" paramName="name"/></security-proxy>
        </XDtClass:ifHasClassTag>
        <XDtClass:ifHasClassTag tagName="jboss:subscriber">
         <mdb-user><XDtClass:classTagValue tagName="jboss:subscriber" paramName="name"/></mdb-user>
         <mdb-passwd><XDtClass:classTagValue tagName="jboss:subscriber" paramName="password"/></mdb-passwd>
	 <XDtClass:ifHasClassTag tagName="jboss:subscriber" paramName="client-id"><mdb-client-id><XDtClass:classTagValue tagName="jboss:subscriber" paramName="client-id"/></mdb-client-id></XDtClass:ifHasClassTag>
         <mdb-subscription-id><XDtClass:classTagValue tagName="jboss:subscriber" paramName="subscription-id"/></mdb-subscription-id>
        </XDtClass:ifHasClassTag>
        <XDtClass:forAllClassTags tagName="jboss:ejb-ref-jndi">
         <ejb-ref>
            <ejb-ref-name>ejb/<XDtClass:classTagValue tagName="jboss:ejb-ref-jndi" paramName="ref-name"/></ejb-ref-name>
            <jndi-name><XDtClass:classTagValue tagName="jboss:ejb-ref-jndi" paramName="jndi-name"/></jndi-name>
         </ejb-ref>
        </XDtClass:forAllClassTags>
        <XDtClass:forAllClassTags tagName="jboss:resource-ref">
         <resource-ref>
            <res-ref-name><XDtClass:classTagValue tagName="jboss:resource-ref" paramName="res-ref-name"/></res-ref-name>
            <XDtClass:ifHasClassTag tagName="jboss:resource-ref" paramName="resource-name">
            <resource-name><XDtClass:classTagValue tagName="jboss:resource-ref" paramName="resource-name"/></resource-name>
            </XDtClass:ifHasClassTag>
            <XDtClass:ifHasClassTag tagName="jboss:resource-ref" paramName="jndi-name">
            <jndi-name><XDtClass:classTagValue tagName="jboss:resource-ref" paramName="jndi-name"/></jndi-name>
            </XDtClass:ifHasClassTag>
            <XDtClass:ifHasClassTag tagName="jboss:resource-ref" paramName="res-url">
            <res-url><XDtClass:classTagValue tagName="jboss:resource-ref" paramName="res-url"/></res-url>
            </XDtClass:ifHasClassTag>
         </resource-ref>
         </XDtClass:forAllClassTags>
         <XDtClass:forAllClassTags tagName="jboss:resource-env-ref">
         <resource-env-ref>
            <resource-env-ref-name><XDtClass:classTagValue tagName="jboss:resource-env-ref" paramName="resource-env-ref-name" mandatory="true"/></resource-env-ref-name>
            <jndi-name><XDtClass:classTagValue tagName="jboss:resource-env-ref" paramName="jndi-name" mandatory="true"/></jndi-name>
         </resource-env-ref>
         </XDtClass:forAllClassTags>
      </message-driven>
     </XDtMerge:merge>
    </XDtEjb:ifIsAConcreteEJBean>
    </XDtEjbMdb:forAllMDBeans>
    </XDtConfig:ifConfigParamGreaterOrEquals>

   </enterprise-beans>

  <XDtMerge:merge file="jboss-resource-managers.xml">
   <resource-managers>
    <XDtEjb:forAllBeans>
    <XDtEjb:ifIsAConcreteEJBean>
     <XDtClass:forAllClassTags tagName="jboss:resource-manager">
      <resource-manager>
         <res-name><XDtClass:classTagValue tagName="jboss:resource-manager" paramName="res-man-name"/></res-name>
         <res-jndi-name><XDtClass:classTagValue tagName="jboss:resource-manager" paramName="res-man-jndi-name"/></res-jndi-name>
      </resource-manager>
     </XDtClass:forAllClassTags>
    </XDtEjb:ifIsAConcreteEJBean>
    </XDtEjb:forAllBeans>
   </resource-managers>
  </XDtMerge:merge>


  <XDtMerge:merge file="jboss-container.xml">
  </XDtMerge:merge>



</jboss>
